import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

/*
<applet code="sphere.class" width=310 height=435>
</applet>
*/

public class Sphere extends java.applet.Applet
	implements MouseListener, MouseMotionListener
{
	Color bgColor=new Color(0,0,0);
	Color barColor=new Color(140,140,180);
	Graphics offGraphics, controlGraphics;
	Image offImage, ballImage, controlImage;
	Image buttonImages[];
	final int numDiv = 4;
	final int numCol = 4;
	Color fgColor[][] = new Color[numCol][20];
    TextField textBox = new TextField("");
	String colorNames[]={"red","green","blue","yellow"};
	int offset;
	int colheight=35;
    int barheight=12;
    int textheight=10;
    int barlength=300;// length of bars in pixels
    int siz=barlength+35+10; // width of viewscreen
	int lastX, lastY;
	int radius;
	int mark=-1, markCol=-1;
	int sym[];
	boolean noball = false;
	boolean controlChange = true;
	final double phi = 0.618034;
	final int numVecSet=7;
	final int numVec[]={4,6,8,12,12,20,30};
    int div[][]={
            {barlength/3,barlength,barlength,barlength},
            {barlength  ,barlength,barlength,barlength},
            {barlength  ,barlength,barlength,barlength},
            {barlength  ,barlength,barlength,barlength}
        };
	final double vec[][][]={
		{
			// tetrahedron corners
			{1,1,1},{1,-1,-1},{-1,1,-1},{-1,-1,1}
		},{
			// octahedron corners / cube faces
			{0,0,1},{0,0,-1},{0,1,0},{0,-1,0},{1,0,0},{-1,0,0}
		},{
			// cube corners / octahedron corners
			{1,1,1},{-1,-1,-1},{-1,1,1},{1,-1,-1},
			{1,-1,1},{-1,1,-1},{1,1,-1},{-1,-1,1}
		},{
			// cube/octahedron edges
			{0,1,1},{0,-1,-1},{0,-1,1},{0,1,-1},
			{1,1,0},{-1,-1,0},{-1,1,0},{1,-1,0},
			{1,0,1},{-1,0,-1},{1,0,-1},{-1,0,1}
		},{
			// icosahedron corners, dodecahedron faces
			{0,1,phi},{0,-1,-phi},{0,-1,phi},{0,1,-phi},
			{1,phi,0},{-1,-phi,0},{-1,phi,0},{1,-phi,0},
			{phi,0,1},{-phi,0,-1},{phi,0,-1},{-phi,0,1}
		},{
			// dodecahedron corners, icosahedron faces
			{1,1,1},{-1,-1,-1},{-1,1,1},{1,-1,-1},
			{1,-1,1},{-1,1,-1},{1,1,-1},{-1,-1,1},
			{0,1,phi+2},{0,-1,-phi-2},{0,-1,phi+2},{0,1,-phi-2},
			{1,phi+2,0},{-1,-phi-2,0},{-1,phi+2,0},{1,-phi-2,0},
			{phi+2,0,1},{-phi-2,0,-1},{phi+2,0,-1},{-phi-2,0,1}
		},{
			// dodecahedron/icosahedron edges
			{0,0,1},{0,0,-1},{0,1,0},{0,-1,0},{1,0,0},{-1,0,0},
			{1,1+phi,phi},{phi,1,1+phi},{1+phi,phi,1},
			{1,1+phi,-phi},{phi,1,-1-phi},{1+phi,phi,-1},
			{1,-1-phi,phi},{phi,-1,1+phi},{1+phi,-phi,1},
			{1,-1-phi,-phi},{phi,-1,-1-phi},{1+phi,-phi,-1},
			{-1,1+phi,phi},{-phi,1,1+phi},{-1-phi,phi,1},
			{-1,1+phi,-phi},{-phi,1,-1-phi},{-1-phi,phi,-1},
			{-1,-1-phi,phi},{-phi,-1,1+phi},{-1-phi,-phi,1},
			{-1,-1-phi,-phi},{-phi,-1,-1-phi},{-1-phi,-phi,-1}
		}
	};

	double eye[][]={
		{1,0.0001,0.0001},
        {0.0001,1,0.0001},
		{0.0001,0.0001,1}
	};

	public void init()
	{
		int i,j;
		//Set size of viewscreen
        setLayout(null);
        add(textBox);
        textBox.setBounds(0,siz+numCol*colheight,siz,20);
        textBox.setEditable(false);
        textBox.setVisible(false);

    	offset=siz/2;
		radius=offset*9/10;

        String par;
		sym=new int[numCol];
		if( getParameter("sym")!=null ){
			j= getParamVal(getParameter("sym"),0)-1;
			if(j<0)j=0;
			if(j>numVecSet)j=numVecSet;
            for(i=0; i<numCol;i++) sym[i]=j;
		}
        for(i=0;i<numCol; i++){
            par = getParameter("sym"+colorNames[i]);
            if(par==null) par = getParameter("sym"+(i+1));
            if( par!=null ){
                j= getParamVal(par,0)-1;
                if(j<0)j=0;
                if(j>numVecSet)j=numVecSet;
                sym[i]=j;
            }
        }

		boolean first=true;
		for(i=0; i<numCol; i++){
            boolean cvpar=false;
            par = getParameter(colorNames[i]);
			if(par==null) {
                par = getParameter("cut"+(i+1));
                if(sym[i]==0) cvpar=true;
            }
			if( par!=null ){
				if(first){	// clear default pattern
					for(int i2=0; i2<numCol; i2++)
						for( j=0; j<numDiv; j++ )
							div[i2][j]=barlength;
					first=false;
				}
				for( j=0; j<numDiv; j++ ){
					int k = getParamVal( par,j );
                    div[i][j] = (k<0 || k>barlength) ? barlength :
                            (cvpar? (barlength+k)/2 : k);
				}
			}
		}

        for( i=0; i<3; i++) normalize(eye[i]);
		if( getParameter("angle")!=null ){
			int ax= getParamVal(getParameter("angle"),0);
			int ay= getParamVal(getParameter("angle"),1)-90;
			int az= getParamVal(getParameter("angle"),2);
			if(ax<0 || ax>=360) ax=0;
			if(ay<-90 || ay>=90) ay=0;
			if(az<0 || az>=360) az=0;
            //[1]z->x[0]
            //   |
            //   v y[2]
            // first angle ax, longitude
            double s=Math.sin(Math.PI*ax/180);
            double c=Math.cos(Math.PI*ax/180);
            eye=matProd(eye,new double[][]{{c,0,s},{0,1,0},{-s,0,c}});
            // second angle ay, lattitude
            s=Math.sin(Math.PI*ay/180);
            c=Math.cos(Math.PI*ay/180);
            eye=matProd(eye,new double[][]{{1,0,0},{0,c,s},{0,-s,c}});
            // second angle az, tilt
            s=Math.sin(Math.PI*az/180);
            c=Math.cos(Math.PI*az/180);
            eye=matProd(eye,new double[][]{{c,s,0},{-s,c,0},{0,0,1}});
		}

		if( getParameter("noball")!=null ){
			noball=true;
		}

		// Set background colour (black)
		setBackground(bgColor);

		for( i=0; i<numVecSet; i++){
			for( j=0; j<numVec[i]; j++){
				normalize(vec[i][j]);
			}
		}

	    MediaTracker tracker = new MediaTracker(this);
	    Image buttonImage = getImage(getDocumentBase(),
	    							getParameter("buttons"));
	    tracker.addImage(buttonImage, 0);

		buttonImages=new Image[14];
		for( i=0; i<14; i++){
			buttonImages[i]=createImage(new FilteredImageSource(
								buttonImage.getSource(),
								new CropImageFilter(35*i,0,35,35) ));
			tracker.addImage(buttonImages[i],1);
		}

		//Double buffer
		offImage=createImage(siz,siz);
		controlImage=createImage(siz,colheight*numCol);
		offGraphics=offImage.getGraphics();
		controlGraphics=controlImage.getGraphics();

		for( i=0; i<8; i++){
			fgColor[0][i] = new Color(32*i,   0,   0);
			fgColor[1][i] = new Color(   0,32*i,   0);
			fgColor[2][i] = new Color(   0,   0,32*i);
			fgColor[3][i] = new Color(32*i,32*i,   0);
		}
		for( i=0; i<12; i++){
			fgColor[0][i+8] = new Color( 255,10*i,10*i);
			fgColor[1][i+8] = new Color(10*i, 255,10*i);
			fgColor[2][i+8] = new Color(10*i,10*i, 255);
			fgColor[3][i+8] = new Color( 255, 255,   0);
		}
		int f;
		ballImage=createImage(siz,siz);
		Graphics g=ballImage.getGraphics();
		g.setColor(bgColor); // Clear drawing buffer
		g.fillRect(0,0,siz,siz);
		if( noball ){
			g.setColor(new Color(250,250,250) ); // draw uniform ball
			g.fillOval(offset-radius,offset-radius,2*radius,2*radius);
		}else{
			for( i=0; i<150; i++ ){
				f = (int)( Math.sqrt(1-(double)i*i/22500.)*(double)radius );
				g.setColor(new Color(i+100,i+100,i+100) ); // draw ball
				g.fillOval(offset-f,offset-f,f+f,f+f);
			}
		}

		// wait till images have finished loading
		try
		{
			tracker.waitForID(0);
			tracker.waitForID(1);
		} catch(InterruptedException e) {}

		addMouseListener(this);
	}
	private int getParamVal(String param, int k){
		int v=0;
		for (int i = 0; i < param.length(); i++){
			if ( param.charAt(i) >= '0' && param.charAt(i) <= '9'){
				if(k==0)
                    v = v*10 + (int)param.charAt(i) - '0';
			}else{
                if(k==0) return v;
				k--;
			}
		}
        return (k==0)?v:-1;
	}
	public void update(Graphics g)
	{
		paint(g);
        textBox.update(g);
	}

	public void paint(Graphics g)
	{
		int i,j,k;

		offGraphics.drawImage(ballImage,0,0,this); // draw ball

		for( j=0; j<numCol; j++){
			for( i=0; i<numVec[sym[j]]; i++){
				for( k=0; k<numDiv; k++){
					if( div[j][k]<barlength ){
                        double f= (double)div[j][k] / barlength;
                        if(sym[j]==0) f=f*2-1;
                        drawCirc( vec[sym[j]][i], f, j );
					}
				}
			}
		}
		g.drawImage(offImage,0,0,this);

		if( controlChange ){
			controlGraphics.setColor(bgColor); // Clear controls buffer
			controlGraphics.fillRect(0,0,siz,colheight*numCol);
			for( i=0; i<numCol; i++){
				controlGraphics.setColor(barColor);
				controlGraphics.fillRect(5,5+i*colheight+textheight+1,barlength,barheight-2);
				controlGraphics.setColor(fgColor[i][12]);
				for( k=0; k<numDiv; k++){
					j = div[i][k];
					controlGraphics.fillRect(j+4,5+i*colheight+textheight,2,barheight);
	                controlGraphics.drawString((j>=barlength?"-":""+j),(k*barlength+barlength/2)/numDiv-10,5+i*colheight+textheight);
				}
			}

            for( i=0; i<numCol; i++){
                if( div[i][0]>=barlength){
                    controlGraphics.drawImage(buttonImages[sym[i]],barlength+8,i*colheight,this);
                }else{
					controlGraphics.drawImage(buttonImages[sym[i]+numVecSet],barlength+8,i*colheight,this);
				}
			}
			controlChange = false;
		}
		g.drawImage(controlImage,0,siz,this);
	}

	int pointsX[]=new int[40];
	int pointsY[]=new int[40];
	double vr[]=new double[3];
	double v1[]=new double[3];
	double v2[]=new double[3];
	// Draw circle on ball surface perp to v1, at distance d from ball centre
	private void drawCirc( double v[], double d, int cl )
	{
		//make orthonormal set v,v1,v2
		vecProd( v1, v, eye[2]);
		normalize( v1 );
		vecProd( v2, v1, v );
		double e = (double)Math.sqrt(1-d*d);
		drawArc( v, v1, v2, d, e, cl );
		v2[0]=-v2[0];v2[1]=-v2[1];v2[2]=-v2[2];
		drawArc( v, v2, v1, d, e, cl );
		v1[0]=-v1[0];v1[1]=-v1[1];v1[2]=-v1[2];
		drawArc( v, v1, v2, d, e, cl );
		v2[0]=-v2[0];v2[1]=-v2[1];v2[2]=-v2[2];
		drawArc( v, v2, v1, d, e, cl );
	}

	private void drawArc( double v[], double v1[], double v2[], double d, double e, int cl )
	{
		final int ac=39;
		int j=0;
		double f;
		for( int i=0; i<=ac; i++ ){
			// get intermediate vector between v1, v2
			vr[0] = (v2[0]*(double)i+v1[0]*(double)(ac-i))/ac;
			vr[1] = (v2[1]*(double)i+v1[1]*(double)(ac-i))/ac;
			vr[2] = (v2[2]*(double)i+v1[2]*(double)(ac-i))/ac;
			normalize(vr);
			vr[0]=vr[0]*e+v[0]*d;
			vr[1]=vr[1]*e+v[1]*d;
			vr[2]=vr[2]*e+v[2]*d;

			//project onto viewer plane
			f = dotProd( vr, eye[2]);
			if( f>=0 ){
				pointsX[j] = offset+(int)(dotProd( vr, eye[0])*radius);
				pointsY[j] = offset+(int)(dotProd( vr, eye[1])*radius);
				if( j>0){
					offGraphics.setColor(fgColor[cl][(int)(f*19)]);
					offGraphics.drawLine(pointsX[j-1],pointsY[j-1],pointsX[j],pointsY[j]);
				}
				j++;
			}
		}
	}
	private void normalize( double v[] ){
		double l=(double)Math.sqrt( v[0]*v[0]+v[1]*v[1]+v[2]*v[2] );
		v[0]/=l; v[1]/=l; v[2]/=l;
	}
	private double dotProd( double v[], double w[]){
		return( v[0]*w[0]+v[1]*w[1]+v[2]*w[2] );
	}
	private void vecProd( double u[], double v[], double w[]){
		u[0] = v[1]*w[2]-v[2]*w[1];
		u[1] = v[2]*w[0]-v[0]*w[2];
		u[2] = v[0]*w[1]-v[1]*w[0];
	}
    private double[][] matProd( double m1[][], double m2[][]){
        double[][] r=new double[3][3];
        for(int i=0; i<3; i++)
            for(int j=0; j<3; j++)
                for(int k=0; k<3; k++)
                    r[i][j]+=m1[i][k]*m2[k][j];
        return r;
    }

	public void mouseClicked(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {
		int i,j,k;
		lastX=e.getX();
		lastY=e.getY();
		// check if control panel clicked
		if( lastY>siz && lastY<siz+numCol*colheight ){
            k=(lastY-siz-5)/colheight;
            if( k>=0 && k<numCol ){
                if( lastX>=barlength+8 ){
				    sym[k]++;
				    if( sym[k]>=numVecSet) sym[k]=0;
                }else{
                    // see if there is a mark nearby
					int c=0,d=barlength;
					for( i=0; i<numDiv; i++ ){
						j = lastX-5 - div[k][i];
						if(j<0) j = -j;
						if(j<d) { d=j; c=i; }
					}
					if( d<7 ){
						mark=c;
						markCol=k;
						div[markCol][mark] = lastX-5;
						if( div[markCol][mark]<0 ) div[markCol][mark]=0;
						if( div[markCol][mark]>barlength ) div[markCol][mark]=barlength;
                        sortDivs();
						addMouseMotionListener(this);
					}
				}
			}
			controlChange = true;
			repaint();
            hideUrl();
        }else if( lastY>siz ){
            showUrl();
        }else{
			addMouseMotionListener(this);
            hideUrl();
		}
	}
	public void mouseReleased(MouseEvent e) {
        removeMouseMotionListener(this);
		if(mark>=0){
            if(div[markCol][mark]==0 && sym[markCol]==0 ) div[markCol][mark]=barlength;
            sortDivs();
            mark=-1;
            repaint();
        }
	}
    private void sortDivs(){
        int f;
        // sort div
        while( mark>0 && div[markCol][mark]<div[markCol][mark-1] ){
           f=div[markCol][mark-1];
           div[markCol][mark-1]=div[markCol][mark];
           div[markCol][mark]=f;
           mark--;
          }
      while( mark<numDiv-1 && div[markCol][mark]>div[markCol][mark+1] ){
         f=div[markCol][mark+1];
         div[markCol][mark+1]=div[markCol][mark];
         div[markCol][mark]=f;
         mark++;
      }
      controlChange = true;
    }
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {
		if( mark>=0){
			int i = e.getX()-5;
			if( i<0 ) i=0;
			if( i>barlength ) i=barlength;
			div[markCol][mark] = i;
            sortDivs();
		}else{
			int dx=e.getX()-lastX;
			int dy=e.getY()-lastY;
			lastX=e.getX();
			lastY=e.getY();
			double f = (double)dx/radius;
			eye[0][0]+=f*eye[2][0];
			eye[0][1]+=f*eye[2][1];
			eye[0][2]+=f*eye[2][2];
			normalize(eye[0]);
			vecProd(eye[2],eye[0],eye[1]);
			f=(double)dy/radius;
			eye[1][0]+=f*eye[2][0];
			eye[1][1]+=f*eye[2][1];
			eye[1][2]+=f*eye[2][2];
			normalize(eye[1]);
			vecProd(eye[2],eye[0],eye[1]);
		}
		repaint();
	}
	public void mouseMoved(MouseEvent e) {}

    public void showUrl(){
        // construct url
        int i,j;
        String url="";
        if(getParameter("url")!=null) url=getParameter("url");

        // do each colour
        for(i=0; i<numCol; i++){
            if( div[i][0]<barlength ){
                url+=colorNames[i]+"=";
                j=0;
                while(j<numDiv && div[i][j]<barlength){
                    if(j>0)url+=",";
                    url+=div[i][j];
                    j++;
                }
                url+="&sym"+colorNames[i]+"="+(sym[i]+1)+"&";
            }
        }

        // do ball
        if(noball) url+="noball&";

        //do angle
        url+="angle=";
        double[][] eye2=new double[3][3];
        for(i=0;i<3;i++)for(j=0;j<3;j++)eye2[i][j]=eye[i][j];
        //get az, tilt angle
        double t=Math.atan2(-eye2[1][0],eye2[1][1]);
        int az = (int)(t*180/Math.PI);
        if( az<0 ) az+=360;
        double s=Math.sin(-t);
        double c=Math.cos(-t);
        eye2=matProd(eye2,new double[][]{{c,s,0},{-s,c,0},{0,0,1}});

        // get ay, lattitude
        t=Math.atan2(-eye2[2][1],eye2[2][2]);
        int ay = (int)(t*180/Math.PI)+90;
        s=Math.sin(-t);
        c=Math.cos(-t);
        eye2=matProd(eye2,new double[][]{{1,0,0},{0,c,s},{0,-s,c}});

        // get ax, longitude
        t=Math.atan2(-eye2[2][0],eye2[2][2]);
        int ax = (int)(t*180/Math.PI);
        if( ax<0 ) ax+=360;

        url+=ax+","+ay+","+az;
        textBox.setText(url);
        textBox.setVisible(true);
        textBox.setBackground(new Color(255,255,255));
    }
    public void hideUrl() {
        textBox.setVisible(false);
    }
}
